﻿@model SYM.DataAccessLayer.route

@{
    ViewBag.Title = SYM.Localization.Resources.Views.Route.Create.AddTopos;
    Layout = "~/Views/Shared/Metr0n1c/_Metr0n1c.4.template.cshtml";
}
<style>
    .controls {
        margin-top: 10px;
        border: 1px solid transparent;
        border-radius: 2px 0 0 2px;
        box-sizing: border-box;
        -moz-box-sizing: border-box;
        height: 32px;
        outline: none;
        box-shadow: 0 2px 6px rgba(0, 0, 0, 0.3);
    }

    #pac-input:focus {
        border-color: #4d90fe;
    }

    .pac-container {
        font-family: Roboto;
        background-color: #FFF;
        z-index: 10100;
        position: fixed;
        display: inline-block;
        float: left;
    }
</style>

<div class="row">
    <div class="col-md-12">
        <div class="note note-info">
            <button type="button" class="close" data-dismiss="alert"></button>
            <p>
                Lascia una traccia del tuo cammino con dati GPS, immagini, stato del percorso o semplici impressioni. In questo modo potrai aiutare chi vorrà ripetere la tua avventura.
            </p>
        </div>
    </div>
</div>
<div class="row">
    <div class="col-md-12">
        <div class="portlet light bordered">
            <div class="portlet-title">
                <div class="caption">
                    <i class="icon-share"></i>
                    <span class="caption-subject font-green-haze bold uppercase">@ViewBag.Title</span>
                </div>
            </div>
            <div class="portlet-body form">
                <!-- BEGIN FORM-->
                @using (Html.BeginForm(Html.BeginForm("Create", "Route", new { ReturnUrl = ViewBag.ReturnUrl }, FormMethod.Post, new { id = "formModal", @class = "form-horizontal" })))
                {
                    @Html.ValidationSummary(true)
                    @Html.HiddenFor(model => model.id)
                    <input type="hidden" id="routeCountry" name="country" value="116">

                    <input type="hidden" id="startCity" name="startCity" value="">
                    <input type="hidden" id="startRegion" name="startRegion" value="">
                    <input type="hidden" id="startCountry" name="startCountry" value="">
                    <input type="hidden" id="startlat" name="startlat" value="">
                    <input type="hidden" id="startlng" name="startlng" value="">
                    <input type="hidden" id="routeMntnAltitude" name="routeMntnAltitude" value="">

                    <ul class="nav nav-tabs">
                        <li class="active">
                            <a href="#tab_rc_1" data-toggle="tab" id="link1"><i class="fa fa-map-marker"></i>Info Generali</a>
                        </li>
                        <li class="">
                            <a href="#tab_rc_2" id="Maps" data-toggle="tab">Dettagli</a>
                        </li>
                        <li class="">
                            <a href="#tab_rc_3" id="Url" data-toggle="tab">External link </a>
                        </li>
                    </ul>
                    <div class="tab-content">
                        <div class="tab-pane fade active in" id="tab_rc_1">
                            <div class="row">
                                <div class="col-md-6">
                                     <div id="gmap_modal" style="width:100%; height:400px;"></div>                              
                                </div>
                                <!--/span-->
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="control-label col-md-4">@SYM.Localization.Resources.Views.Route.Details.Activity <span class="required" aria-required="true">*</span></label>
                                        <div class="col-md-8">
                                            <select name="routeActivity" id="modal-activity" class="bs-select form-control" data-show-subtext="true">
                                                <option data-subtext="<span class='badge badge-success badge-roundless'>Trekking & Hiking</span>" value="6">Escursionismo</option>
                                                <option data-subtext="<span class='badge badge-warning badge-roundless'>Alpinism</span>" value="7">Via Ferrata</option>
                                                <option data-subtext="<span class='badge badge-danger badge-roundless'>Alpinism</span>" value="17">Via su Roccia</option>
                                                <option data-subtext="<span class='badge badge-info badge-roundless'>Alpinism</span>" value="12">Ghiaccio & Misto</option>
                                                <option data-divider="true"></option>
                                                <option data-subtext="<span class='badge badge-info badge-roundless'>Snow & Ice</span>" value="13">Cascate di ghiaccio</option>
                                                <option data-subtext="<span class='badge badge-info badge-roundless'>Snow & Ice</span>" value="9">Scialpinismo</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <label class="control-label col-md-4">@SYM.Localization.Resources.Views.Route.Details.Region <span class="required" aria-required="true">*</span></label>
                                        <div class="col-md-8">
                                            <select id="routeRegion" name="routeRegion" class="form-control select2remote">
                                                <option value="1736" selected>Lombardia</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <label class="control-label col-md-4">@SYM.Localization.Resources.Views.Route.Details.Mountain</label>
                                        <div class="col-md-8 has-warning">
                                            <select id="routeMntn" name="routeMntn" class="form-control select2"></select>
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <label class="control-label col-md-4">@SYM.Localization.Resources.Views.Route.Details.MountainRange</label>
                                        <div class="col-md-8">
                                            <select id="routeMntnRange" name="routeMntnRange" class="form-control select2" disabled="disabled" data_placeholder="Select mountain range...">
                                                <option value=""></option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <label class="control-label col-md-4">Località Partenza <span class="required" aria-required="true">*</span></label>
                                        <div class="col-md-8">
                                            <input id="pac-input" name="routeCity" class="form-control" type="text" placeholder="Seleziona località di partenza">
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <label class="control-label col-md-4">Name @SYM.Localization.Resources.Views.Route.Details.Route<span class="required" aria-required="true">*</span></label>
                                        <div class="col-md-8">
                                            <div class="input-icon right">
                                                <i class="fa fa-info-circle tooltips" data-original-title="Non indicare..." data-container="body"></i>
                                                @Html.TextBoxFor(model => model.route_name, new { @class = "form-control", @placeholder = "ex. via normale/cresta Sud/sentiero attrezzato" })
                                            </div>
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <div class="col-md-4">
                                        </div>
                                        <div class="col-md-8">
                                            <div class="alert alert-info hidden" id="console">                                          
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--/span-->
                            </div>
                            <!--/row-->
                            <!--/row-->
                            @*<div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="control-label col-md-4">@SYM.Localization.Resources.Views.Route.Details.Valley</label>
                                        <div class="col-md-8">
                                            <select id="routeValley" name="routeValley" class="form-control select2">
                                                <option value=""></option>
                                            </select>
                                        </div>
                                    </div>
                                </div>
                            </div>*@
                            <!--/row-->
                        </div>
                        <div class="tab-pane fade" id="tab_rc_2">
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="control-label col-md-4">Max Altitudine</label>
                                        <div class="col-md-4">
                                            @Html.TextBoxFor(model => model.route_altitude, new { @class = "form-control", placeholder = "ex. 1000 m.", type = "number" })
                                            @Html.ValidationMessageFor(model => model.route_altitude)
                                        </div>
                                        
                                    </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="control-label col-md-4">Lunghezza / Dislivello</label>
                                        <div class="col-md-4">
                                            @Html.TextBoxFor(model => model.route_length, new { @class = "form-control", placeholder = "ex. 7.6 Km.", type = "number" })
                                            @Html.ValidationMessageFor(model => model.route_length)
                                        </div>
                                        <div class="col-md-4">
                                            @Html.TextBoxFor(model => model.route_height, new { @class = "form-control", placeholder = "ex. 400 m.", type = "number" })
                                            @Html.ValidationMessageFor(model => model.route_height)
                                        </div>
                                    </div>
                                </div>
                                <!--/span-->
                            </div>
                            <!--/row-->
                            <div class="row">
                                <!--/span-->
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="control-label col-md-4">@SYM.Localization.Resources.Views.Route.Details.Difficulty / @SYM.Localization.Resources.Views.Route.Details.Pitch</label>
                                        <div class="col-md-4">
                                            @Html.TextBoxFor(model => model.difficulty_grade, new { @class = "form-control" })
                                            @Html.ValidationMessageFor(model => model.difficulty_grade)
                                        </div>
                                        <div class="col-md-4">
                                            @Html.TextBoxFor(model => model.route_pitchAsc, new { @class = "form-control", type = "text", id = "touchspin_5", placeholder = "N° Tiri" })
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="control-label col-md-4">@SYM.Localization.Resources.Views.Route.Details.Exposure</label>
                                        <div class="col-md-8">
                                            <select name="route_facing" class="form-control select2me" multiple="multiple" placeholder="Principale esposizione">
                                                <option value="N">Nord</option>
                                                <option value="NW">Nord-Ovest</option>
                                                <option value="NE">Nord-Est</option>
                                                <option value="W">Ovest</option>
                                                <option value="E">Est</option>
                                                <option value="S">Sud</option>
                                                <option value="SW">Sud-Ovest</option>
                                                <option value="SE">Sud-Est</option>
                                            </select>
                                        </div>
                                    </div>
                                 </div>
                            </div>
                            <!--/row-->
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="control-label col-md-4">1° Ascent Date</label>
                                        <div class="col-md-8">
                                            @Html.TextBoxFor(model => model.route_firstAscDate, new { @class = "form-control", type = "date" })
                                        </div>
                                    </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="control-label col-md-4">Climbers</label>
                                        <div class="col-md-8">
                                            @Html.TextBoxFor(model => model.route_firstAscClimbers, new { @class = "form-control" })
                                        </div>
                                    </div>
                                </div>
                                <!--/span-->
                            </div>
                        </div>
                        <div class="tab-pane fade" id="tab_rc_3">
                            <div class="row">
                                <div class="col-md-12">
                                    <div class="form-group">
                                        <div class="row margin-top-20">
                                            <label class="control-label col-md-2">Url / PDF</label>
                                            <div class="col-md-9">
                                                <input id="wi_url" name="wi_url" type="url" class="form-control" value="" placeholder="ex. http://site.com/itinerario/page.html">
                                            </div>
                                            <div class="col-md-1"></div>
                                        </div>
                                    </div>
                                </div>
                                <!--/span-->
                            </div>
                            <!--/row-->
                        </div>
                    </div>
                    <div class="row margin-top-20">
                        <div class="col-md-12 text-right">
                            <button type="button" class="btn default">Close</button>
                            <button type="button" class="btn btn-primary" id="myModal_submit">@SYM.Localization.Resources.Views.Route.Create.Submit</button>
                        </div>
                    </div>
                }
                <!-- END FORM-->
            </div>
        </div>
    </div>
</div>
@section scripts {
<script type="text/javascript">

    MyApp.init();

    $('#routeMntn').on("select2-selecting", function (e) {
        $('#routeMntnRange').select2('enable', false);
        $('#routeMntnGroup').select2('enable', false);
    });

    MyApp.Select2Region('#routeRegion', '/api/autocomplete/GetRegion', 'Select Region...');
    MyApp.Select2LookupMountain('#routeMntn', '/api/autocomplete/GetMountains', '#routeCountry', '#routeRegion', 'Select Mountain...');
    //MyApp.Select2LookupSym('#routeValley', '/api/autocomplete/GetValleys', '#routeCountry', '#routeRegion', 'Select Valley...');

    $("#touchspin_5").TouchSpin({
        max: 50
    });

    //Init Map

    //TODO CREATE CLASS FOR UTILITY GMAPS
    function SetInputs4Location(addressArray,lat,lng) {

        for (i = 0; i < addressArray.length; i++) {
            switch (addressArray[i].types[0]) {
                case "locality":
                    //console.log("city " + addressArray[i].short_name);
                    $("#startCity").val(addressArray[i].short_name);
                    break;
                case "administrative_area_level_1":
                    //console.log("region " + addressArray[i].long_name);
                    $("#startRegion").val(addressArray[i].long_name);
                    break;
                case "country":
                    //console.log("country " + addressArray[i].short_name);
                    $("#startCountry").val(addressArray[i].short_name);
                    break;
            }
        }

        $("#startlat").val(lat);
        $("#startlng").val(lng);
    }

    var iconBase = 'http://maps.google.com/mapfiles/kml/pal2/';
    var icons = {
        car: {
            icon: iconBase + 'icon47.png'
        },
        meta: {
            icon: iconBase + 'icon13.png'
        },
        parking: {
            icon: 'http://www.gstatic.com/mapspro/images/stock/1453-trans-parking.png'
        }
    };
    var map;
    var mapGeocoding = function () {
        map = new GMaps({
            div: '#gmap_modal',
            lat: 45.4667015,
            lng: 9.1999998,
            zoom: 12,
            mapTypeControlOptions: {
                mapTypeIds: ["roadmap", "satellite", "osm"]
            }
        });
        map.addMapType("osm", {
            getTileUrl: function (coord, zoom) {
                return "https://a.tile.openstreetmap.org/" + zoom + "/" + coord.x + "/" + coord.y + ".png";
            },
            tileSize: new google.maps.Size(256, 256),
            name: "OpenStreetMap",
            maxZoom: 18
        });
        map.setMapTypeId("osm");
    };
    var mntn_lat, mntn_lng, mntn_txt;
        
    setTimeout("mapGeocoding();", 200);

    $('#routeMntn').on("select2:selecting", function (e) {
        $.ajax({
            type: "POST",
            url: "/api/autocomplete/GetMountain",
            data: '{p_mountainId:"' + e.params.args.data.id + '"}',
            contentType: "application/json; charset=utf-8",
            cache: false,
            success: function (data) {
                console.log(data[0].name);
                map.addMarker({
                    lat: data[0].lat,
                    lng: data[0].lng,
                    title: "" + data[0].name + " - " + data[0].altitude + " m.",
                    label: "M",
                    infoWindow: {
                        content: "" + data[0].name + ""
                    }
                });
                map.setCenter(data[0].lat, data[0].lng);
                map.zoom = 12;
                //Set
                $('#route_altitude').val(data[0].altitude);
                mntn_lat = data[0].lat;
                mntn_lng = data[0].lng;
                mntn_txt = "" + data[0].name + " - " + data[0].altitude + " m.";
            },
            error: function () {
                console.log("Error page stats");
            }
        });

    });
    $('#routeRegion').on("select2:selecting", function (e) {
        $("#routeCountry").val(e.params.args.data.country_id);
    });

    var options = {
        types: ['(cities)']
    };

    var input = (document.getElementById('pac-input'));

    autocomplete = new google.maps.places.Autocomplete(input, options);
    google.maps.event.addListener(autocomplete, 'place_changed', function () {
        var place = autocomplete.getPlace();
        if (!place.geometry) {
            window.alert("Autocomplete's returned place contains no geometry");
            return;
        }
        map.removeMarkers();

        SetInputs4Location(place.address_components, place.geometry.location.lat(), place.geometry.location.lng());

        map.setCenter(place.geometry.location.lat(), place.geometry.location.lng());

        //Start
        map.addMarker({
            lat: place.geometry.location.lat(),
            lng: place.geometry.location.lng(),
            icon: icons["meta"].icon,
            title: 'Località Partenza'
        });
        //Peak
        map.addMarker({
            lat: mntn_lat,
            lng: mntn_lng,
            label: "M",
            title: mntn_txt
        });

        //EXTERNALIZE ELEVATION
        map.getElevations({
            locations: [[place.geometry.location.lat(), place.geometry.location.lng()]],
            callback: function (result, status) {
                if (status == google.maps.ElevationStatus.OK) {
                    var tmp = $('#route_altitude').val();
                    var dislivello = (parseInt(tmp) - Math.round(result[0].elevation));
                    $("#console").html("<strong>Info!</strong> Dislivello stimato: " + dislivello + "m.");
                    $("#console").removeClass("hidden");
                }
            }
        });
    });

</script>
}

